/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package javausb;
import java.io.UnsupportedEncodingException;
import javax.usb.*;
import java.util.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.usb4java.javax.*;
/**
 *
 * @author User
 */
public class JavaUSB {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        UsbHub vRootHub = getVirtualRootUsbHub();
        processGetUsbPorts(vRootHub,"");
    }
    
    public static UsbHub getVirtualRootUsbHub(){
        UsbServices services = null;
        UsbHub VirtualRootUsbHub = null;
        
        try{
            services = UsbHostManager.getUsbServices();
        } catch (UsbException | SecurityException e){
            throw new RuntimeException("Error : " + e.getMessage());
        }
        
        try {
            VirtualRootUsbHub = services.getRootUsbHub();
        } catch (UsbException | SecurityException e){
            throw new RuntimeException("Error : " + e.getMessage());
        }
        
        return VirtualRootUsbHub;
    }
    
    public static void processGetUsbPorts(UsbDevice device, String prefix){
        UsbHub hub = null;
        String manInfo="",prodInfo="",idProduct="",idVendor="";
        //Проверяем, является ли device хабом
        if(!device.isUsbHub()){
            try{
                manInfo = device.getManufacturerString();
                prodInfo = device.getProductString();
                idProduct = Long.toHexString(device.getUsbDeviceDescriptor().idProduct());
                idVendor = Long.toHexString(device.getUsbDeviceDescriptor().idVendor());
            } catch(UsbException | UnsupportedEncodingException | UsbDisconnectedException e){
//              System.out.println("error");
            }
            System.out.println(prefix+device.toString()+" on port #"+device.getParentUsbPort().getPortNumber());
            if(!(prodInfo=="")) System.out.println(prefix+"\t"+manInfo+" : "+prodInfo);
            if(!(idVendor=="")) System.out.println(prefix+"\tPID:VID\t"+idVendor+":"+idProduct);
            return;
        } else{
            hub = (UsbHub)device;
        }
    
        System.out.println(prefix+"UsbHub: "+hub.toString().substring(9));
        //Получаем список портов
        List usbPorts = hub.getUsbPorts();
        for(int i=0;i<usbPorts.size();i++){
           UsbPort port = (UsbPort) usbPorts.get(i);
           //Проверяем, подключены ли к порту устройства
           if(!port.isUsbDeviceAttached()){
               System.out.println(prefix+PREFIX+"usbPort "+port.toString());
           } else{
               processGetUsbPorts(port.getUsbDevice(),prefix+PREFIX);
           }
        }
    }
    
    public static final String PREFIX = "\t";
}
